#include <string.h>
#include <stdlib.h>
#include "global.h"
#include "app.h"
#include "c_app.h"
#include "i_app.h"
#include "w_app.h"

#include "k_stdtype.h"
#include "mal.h"
#include "sleep.h"

uint32 doAppSleep = 0;
uint8 myLed = 0;

void init_app(void) {
	TRISGbits.TRISG6 = 0;
	LATGbits.LATG6 = 0;

	TRISDbits.TRISD1 = 0;
	LATDbits.LATD1 = 0;
}

void do_app(void) {
	static unsigned char appSingleShoot = 1;
	if (appSingleShoot) {
		appSingleShoot = 0;
	}
	if (doAppSleep) {
		doAppSleep = 0;
		sleep_Request(-1);
	}
}

void isr_app1ms(void) {
	static uint32 appSleepDelay = 0;
	appSleepDelay++;
	if (appSleepDelay >= 3500) {
		appSleepDelay = 0;
		doAppSleep = 1;
	}
}

void isr_app100us(void) {
}

void beforeSleepUser(void) {
	TRISB = 0xFFFF;

	TRISC = 0xFFFF;

	TRISD = 0xFFFF;
	TRISDbits.TRISD1 = 0;
	LATDbits.LATD1 = 0;

	TRISF = 0xFFFF;
	
	TRISG = 0xFFFF;
	TRISGbits.TRISG6 = 0;
	LATGbits.LATG6 = 0;

	TRISE = 0xFFFF;

	SYSKEY = 0x0;  // write invalid key to force lock
	SYSKEY = 0xAA996655;  // Write Key1 to SYSKEY
	SYSKEY = 0x556699AA;  // Write Key2 to SYSKEY
	OSCCONSET = 0x10; // set Power-Saving mode to Sleep
	SYSKEY = 0x0;  // write invalid key to force lock

	//LATGbits.LATG6 = 1;
}

uint8 backToSleep(void) {
	uint8 result = 1;
	if (myLed) {
		myLed = 0;
		//LATDbits.LATD1 = 0;
	} else {
		myLed = 1;
		//LATDbits.LATD1 = 1;
	}
	return result;
}

void afterSleepUser(void) {
	//LATGbits.LATG6 = 0;
}

